module Strategize
  class PolicyEvaluator
    def initialize(rule_evaluator)
      @rule_evaluator = rule_evaluator
    end

    def evaluate(*policies, subject)
      policies.flatten!
      results = policies.map do |policy|
        rules = policy.rule_group.rules
        rule_digest = @rule_evaluator.evaluate(subject, rules)
        PolicyEvaluation.new(policy, rule_digest)
      end
      PolicyEvaluationDigest.new(results, subject)
    end
  end
end
