module Strategize
  class RuleEvaluator
    # Given an array of rules, evaluates each rule and returns
    # the results
    #
    # @param rules [Array<Rule>] rules to be evaluated
    # @param subject [Object] the object to evaluate rules against
    def evaluate(subject, *rules)
      rules.flatten!
      results = rules.map do |rule|
        RuleEvaluation.new(rule, rule.evaluate(subject))
      end
      RuleEvaluationDigest.new(results, subject)
    end
  end
end
