module Strategize
  # Raised when a class does not include
  # the Stategize::Policy module.
  NotPolicyError = Class.new(RuntimeError)

  # Raised when an object that does not respond to
  # call is provided in [Rule] initialization.
  InvalidPredicateError = Class.new(RuntimeError)

  # Raised when an object that does not respond to
  # call is provided in [Operation] initialization.
  InvalidFunctionError = Class.new(RuntimeError)

  InvalidRuleEvaluator = Class.new(RuntimeError)
  InvalidPolicyEvaluator = Class.new(RuntimeError)
end
