module Strategize
  class RuleEvaluationDigest
    attr_reader :evaluations, :subject

    def initialize(evaluations, subject)
      @evaluations = evaluations
      @subject = subject
    end

    def result
      @evaluations.all?(&:result)
    end

    def rules
      @evaluations.map(&:rule)
    end

    def passed
      @evaluations
        .select { |evaluation| evaluation.result == true }
        .map(&:rule)
    end

    def failed
      @evaluations
        .select { |evaluation| evaluation.result == false }
        .map(&:rule)
    end
  end
end
