module Strategize
  # A wrapper around an array of rules
  class RuleGroup
    attr_reader :rules

    # Create new Rule Group
    #
    # @param rules [Array<Rule>] rules to be evaluated
    def initialize(rules = [])
      @rules = rules
    end

    # Add [Rule] to the group
    #
    # @param name [Symbol] a descriptive name for the rule
    # @param predicate [Lambda] a function that returns true or false
    def add(name, predicate)
      @rules.push(Rule.new(name, predicate))
    end

    def <<(name, predicate)
      add(name, predicate)
    end
  end
end
